 ; UNPGE20 Pretty Good Envelope v2.0
 ;  Envelope opener
 ; Copyright 4/27/98
 ; by Robert G. Durnal
TITLE UNPGE20
PAGE 60
 .model tiny
 .radix 16
 .386
 _code segment use16
readsize equ 8000
readbuf equ 1000
 assume cs:_code,ds:_code,es:_code
 org 100
START:
 mov si,80
 lodsw
 or al,al
 jz short prog
 call docscreen
PROG:
 mov dx,offset getenv
 mov bp,1   ; Fail if not exist
 call getfile  ; Open envelope file
 mov ax,4202                  
 xor cx,cx
 mov dx,cx
 int 21        ; Set pointer to EOF
 sub ax,4      ; Back up 4 bytes
 sbb dx,0      ;  if AX was < 4
 xchg cx,dx
 xchg dx,ax
 mov ax,4200
 int 21        ; Point to new position
 mov dx,offset readerr
 jc filerror
 mov cx,4
 mov dx,readbuf
 mov ah,3F
 int 21        ; Read last 4 bytes 
 mov dx,offset readerr
 jc filerror
 mov si,readbuf
 lodsw
 xchg ax,dx
 lodsw
 xchg ax,cx
 mov ax,4200
 int 21        ; Pointer to old EOF
 mov ah,3F
 mov cx,readsize
 mov dx,readbuf
 int 21        ; And read the file
 mov dx,offset readerr
 jc filerror
 sub ax,4      ; Correct for pointer
 push ax
 mov dx,offset getmsg
 mov bp,12   ; Create or replace
 call getfile  ; Open output file
 mov ah,40
 mov dx,readbuf
 pop cx
 int 21        ; Write the message
 mov dx,offset writerr
 jc filerr1
 int 20
FILERROR:
 mov ah,9
 int 21
 mov dx,offset fnamebuf+2
FILERR1:
 mov ah,9
 int 21
DONE:
 int 20
GETFILE:
 mov ah,9      ; DX must be preset
 int 21
 mov ah,0A
 mov dx,offset fnamebuf
 int 21        ; Get file name from KB
 xchg bx,dx
 mov al,byte ptr [bx+1]
 cbw
 add bx,ax
 mov word ptr [bx+2],2400 ; ASCIIZ
 mov ax,6C00
 mov bx,2
 mov cx,0
 mov dx,bp
 mov si,offset fnamebuf+2
 int 21
 mov dx,offset openerr
 jc filerror
 xchg ax,bx    ; Handle in BX
 ret
DOCSCREEN: ; Subroutine to 
 ; search environment block
 ; for PATH variable, search
 ; for PGE20.DOC in path
 mov ax,3D00 ; Check current dir
 mov dx,offset fnamebuf+2
 int 21
 xchg ax,bx
 jnc short docscr1
 call openpath
DOCSCR1:
 mov ah,3F
 mov dx,readbuf
 mov cx,readsize
 int 21
 mov dx,offset readerr
 jc filerror
 mov dx,readbuf
 mov ah,9
 int 21
 ret
OPENPATH:
 xor si,si
FINDLOOP:
 db 8E,1E,2C,00 ; mov ds,[2c]
 lodsd
 cmp eax,48544150
 jz short pathfound
FINDZERO:
 lodsb
 or al,al
 jnz findzero
 lodsb
 dec si
 or al,al
 jnz findloop
ENDOFENV:
 push es
 pop ds  ; Restore DS
 mov dx,offset nopath
 mov ah,9
 int 21
 mov dx,offset fnamebuf+2
 int 21
 jmp done
PATHFOUND:
 lodsb
 cmp al,'='
 jnz findzero ; Not the right PATH
NEXTPATH:
 db 8E,1E,2C,00 ; mov ds,[2c]
 cmp byte ptr [si-1],0
 jz endofenv ; Dir was last in PATH
 mov di,offset pathbuf
PATHLOOP:
 lodsb
 stosb
 or al,al
 jz short pl1
 cmp al,';'
 jnz pathloop
PL1:
 dec di
 mov al,'\'
 stosb
 push es
 pop ds ; Restore DS 
 push si
 mov si,offset fnamebuf+2
 mov dx,offset pathbuf
GETFNAME:
 lodsb
 stosb
 cmp al,'$'
 jnz getfname
 pop si  ; back to env blk ptr
 mov ax,3D00
 int 21
 jc nextpath
 mov bx,ax
 ret 
OPENERR:
 db 0Dh,0A,'Error opening file $'
READERR:
 db 0Dh,0A,'Error reading file $'
WRITERR:
 db 0Dh,0A,'Error writing to output file$'
GETENV:
 db 'Envelope file name: $'
GETMSG:
 db 0Dh,0A,'Message file name: $'
NOPATH:
 db 0Dh,0A,'No path found for $'
FNAMEBUF:
 db 25 ; Allow 36 char file spec
 db 9,'PGE20.DOC',0,24
PATHBUF:
 db 24 dup (0)
 end start
 